# Data as Code

This package provides tools which can be used to strictly define, version control,
and document data. To sum it up, this package treats Data as Code (DaC) in the
instances where that is possible.

This framework is designed for tabular, file-based data sets, and works best with
fixed, unchanging files (although it can also be used for changing data, but some
of the tools in this framework are rendered moot by these changes).

The product generated by this framework is a tabular data set which includes
complete documentation of the original source, intermediate steps of transformation,
and hash sums to guarantee that the data match the associated code.


Stages:
 - Get
 - (Optional) unpack/inflate
 - Parse
 - Transform
 - Package
 - Distribute
